Package: org.codehaus.groovy.classgen.asm.util

## [Java] Class LoggableTextifier

- org.codehaus.groovy.classgen.asm.util.LoggableTextifier

-     public class LoggableTextifier
      extends org.objectweb.asm.util.Textifier

  Logging bytecode generation, which can make debugging easy

  Since:
    2.5.0

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class org.objectweb.asm.util.Textifier` | `INTERNAL_NAME, FIELD_DESCRIPTOR, FIELD_SIGNATURE, METHOD_DESCRIPTOR, METHOD_SIGNATURE, CLASS_SIGNATURE, HANDLE_DESCRIPTOR, OPCODES, TYPES, HANDLE_TAG, text`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `LoggableTextifier()` Creates a textifier that uses the default compiler configuration for stack-trace enrichment.
    `LoggableTextifier(CompilerConfiguration compilerConfiguration)` Creates a textifier that logs emitted bytecode using the supplied compiler configuration.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected org.objectweb.asm.util.Textifier` | `createTextifier()` Creates a new org.objectweb.asm.util.Textifier. Returns: a new org.objectweb.asm.util.Textifier.
    `` | `protected void` | `log()` Logs any newly collected bytecode text since the previous visitor callback.
    `` | `public void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)`
    `` | `public void` | `visit(String name, Object value)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitAnnotableParameterCount(int parameterCount, boolean visible)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitAnnotation(String name, String desc)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitAnnotation(String desc, boolean visible)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitAnnotationDefault()`
    `` | `public void` | `visitAnnotationEnd()`
    `` | `public org.objectweb.asm.util.Textifier` | `visitArray(String name)`
    `` | `public void` | `visitAttribute(org.objectweb.asm.Attribute attr)` Prints a disassembled view of the given attribute. Parameters: `attribute` - an attribute.
    `` | `public org.objectweb.asm.util.Textifier` | `visitClassAnnotation(String desc, boolean visible)`
    `` | `public void` | `visitClassAttribute(org.objectweb.asm.Attribute attr)`
    `` | `public void` | `visitClassEnd()`
    `` | `public org.objectweb.asm.util.Printer` | `visitClassTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `public void` | `visitCode()`
    `` | `public void` | `visitEnum(String name, String desc, String value)`
    `` | `public void` | `visitExport(String export, int access, String modules)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitField(int access, String name, String desc, String signature, Object value)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitFieldAnnotation(String desc, boolean visible)`
    `` | `public void` | `visitFieldAttribute(org.objectweb.asm.Attribute attr)`
    `` | `public void` | `visitFieldEnd()`
    `` | `public void` | `visitFieldInsn(int opcode, String owner, String name, String desc)`
    `` | `public org.objectweb.asm.util.Printer` | `visitFieldTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `public void` | `visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)`
    `` | `public void` | `visitIincInsn(int varIndex, int increment)`
    `` | `public void` | `visitInnerClass(String name, String outerName, String innerName, int access)`
    `` | `public void` | `visitInsn(int opcode)`
    `` | `public org.objectweb.asm.util.Printer` | `visitInsnAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `public void` | `visitIntInsn(int opcode, int operand)`
    `` | `public void` | `visitInvokeDynamicInsn(String name, String desc, org.objectweb.asm.Handle bsm, Object bsmArgs)`
    `` | `public void` | `visitJumpInsn(int opcode, org.objectweb.asm.Label label)`
    `` | `public void` | `visitLabel(org.objectweb.asm.Label label)`
    `` | `public void` | `visitLdcInsn(Object cst)`
    `` | `public void` | `visitLineNumber(int line, org.objectweb.asm.Label start)`
    `` | `public void` | `visitLocalVariable(String name, String desc, String signature, org.objectweb.asm.Label start, org.objectweb.asm.Label end, int index)`
    `` | `public org.objectweb.asm.util.Printer` | `visitLocalVariableAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, org.objectweb.asm.Label[] start, org.objectweb.asm.Label[] end, int[] index, String desc, boolean visible)`
    `` | `public void` | `visitLookupSwitchInsn(org.objectweb.asm.Label dflt, int[] keys, org.objectweb.asm.Label[] labels)`
    `` | `public void` | `visitMainClass(String mainClass)`
    `` | `public void` | `visitMaxs(int maxStack, int maxLocals)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitMethodAnnotation(String desc, boolean visible)`
    `` | `public void` | `visitMethodAttribute(org.objectweb.asm.Attribute attr)`
    `` | `public void` | `visitMethodEnd()`
    `` | `public void` | `visitMethodInsn(int opcode, String owner, String name, String desc)` Method instruction. See jdk.internal.org.objectweb.asm.MethodVisitor#visitMethodInsn. deprecated: use visitMethodInsn(int, String, String, String, boolean) instead. Parameters: `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE. `owner` - the internal name of the method's owner class (see jdk.internal.org.objectweb.asm.Type#getInternalName()). `name` - the method's name. `descriptor` - the method's descriptor (see jdk.internal.org.objectweb.asm.Type).
    `` | `public void` | `visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)`
    `` | `public org.objectweb.asm.util.Printer` | `visitMethodTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `public org.objectweb.asm.util.Printer` | `visitModule(String name, int access, String version)`
    `` | `public void` | `visitModuleEnd()`
    `` | `public void` | `visitMultiANewArrayInsn(String desc, int dims)`
    `` | `public void` | `visitNestHost(String nestHost)`
    `` | `public void` | `visitNestMember(String nestMember)`
    `` | `public void` | `visitOpen(String packaze, int access, String modules)`
    `` | `public void` | `visitOuterClass(String owner, String name, String desc)`
    `` | `public void` | `visitPackage(String packaze)`
    `` | `public void` | `visitParameter(String name, int access)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitParameterAnnotation(int parameter, String desc, boolean visible)`
    `` | `public void` | `visitPermittedSubclass(String permittedSubclass)`
    `` | `public void` | `visitProvide(String provide, String providers)`
    `` | `public org.objectweb.asm.util.Printer` | `visitRecordComponent(String name, String descriptor, String signature)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitRecordComponentAnnotation(String descriptor, boolean visible)`
    `` | `public void` | `visitRecordComponentAttribute(org.objectweb.asm.Attribute attribute)`
    `` | `public void` | `visitRecordComponentEnd()`
    `` | `public org.objectweb.asm.util.Printer` | `visitRecordComponentTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String descriptor, boolean visible)`
    `` | `public void` | `visitRequire(String require, int access, String version)`
    `` | `public void` | `visitSource(String file, String debug)`
    `` | `public void` | `visitTableSwitchInsn(int min, int max, org.objectweb.asm.Label dflt, org.objectweb.asm.Label labels)`
    `` | `public org.objectweb.asm.util.Printer` | `visitTryCatchAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)`
    `` | `public void` | `visitTryCatchBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label handler, String type)`
    `` | `public org.objectweb.asm.util.Textifier` | `visitTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)` Prints a disassembled view of the given type annotation. Parameters: `typeRef` - a reference to the annotated type. See TypeReference. `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole. `descriptor` - the class descriptor of the annotation class. `visible` - true if the annotation is visible at runtime. Returns: a visitor to visit the annotation values.
    `` | `public void` | `visitTypeInsn(int opcode, String type)`
    `` | `public void` | `visitUse(String use)`
    `` | `public void` | `visitVarInsn(int opcode, int varIndex)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class org.objectweb.asm.util.Textifier` | `org.objectweb.asm.util.Textifier#appendString(java.lang.StringBuilder, java.lang.String), org.objectweb.asm.util.Textifier#equals(java.lang.Object), org.objectweb.asm.util.Textifier#getClass(), org.objectweb.asm.util.Textifier#getText(), org.objectweb.asm.util.Textifier#hashCode(), org.objectweb.asm.util.Textifier#main([Ljava.lang.String;), org.objectweb.asm.util.Textifier#notify(), org.objectweb.asm.util.Textifier#notifyAll(), org.objectweb.asm.util.Textifier#print(java.io.PrintWriter), org.objectweb.asm.util.Textifier#toString(), org.objectweb.asm.util.Textifier#visit(int, int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visit(java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitAnnotableParameterCount(int, boolean), org.objectweb.asm.util.Textifier#visitAnnotableParameterCount(int, boolean), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitAnnotation(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitAnnotationDefault(), org.objectweb.asm.util.Textifier#visitAnnotationDefault(), org.objectweb.asm.util.Textifier#visitAnnotationEnd(), org.objectweb.asm.util.Textifier#visitArray(java.lang.String), org.objectweb.asm.util.Textifier#visitArray(java.lang.String), org.objectweb.asm.util.Textifier#visitAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitClassAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitClassAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitClassEnd(), org.objectweb.asm.util.Textifier#visitClassTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitCode(), org.objectweb.asm.util.Textifier#visitEnum(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitExport(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitField(int, java.lang.String, java.lang.String, java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitField(int, java.lang.String, java.lang.String, java.lang.String, java.lang.Object), org.objectweb.asm.util.Textifier#visitFieldAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitFieldAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitFieldAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitFieldEnd(), org.objectweb.asm.util.Textifier#visitFieldInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitFieldTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitFrame(int, int, [Ljava.lang.Object;, int, [Ljava.lang.Object;), org.objectweb.asm.util.Textifier#visitIincInsn(int, int), org.objectweb.asm.util.Textifier#visitInnerClass(java.lang.String, java.lang.String, java.lang.String, int), org.objectweb.asm.util.Textifier#visitInsn(int), org.objectweb.asm.util.Textifier#visitInsnAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitIntInsn(int, int), org.objectweb.asm.util.Textifier#visitInvokeDynamicInsn(java.lang.String, java.lang.String, org.objectweb.asm.Handle, [Ljava.lang.Object;), org.objectweb.asm.util.Textifier#visitJumpInsn(int, org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitLabel(org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitLdcInsn(java.lang.Object), org.objectweb.asm.util.Textifier#visitLineNumber(int, org.objectweb.asm.Label), org.objectweb.asm.util.Textifier#visitLocalVariable(java.lang.String, java.lang.String, java.lang.String, org.objectweb.asm.Label, org.objectweb.asm.Label, int), org.objectweb.asm.util.Textifier#visitLocalVariableAnnotation(int, org.objectweb.asm.TypePath, [Lorg.objectweb.asm.Label;, [Lorg.objectweb.asm.Label;, [I, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitLookupSwitchInsn(org.objectweb.asm.Label, [I, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Textifier#visitMainClass(java.lang.String), org.objectweb.asm.util.Textifier#visitMaxs(int, int), org.objectweb.asm.util.Textifier#visitMethod(int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitMethod(int, java.lang.String, java.lang.String, java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitMethodAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitMethodEnd(), org.objectweb.asm.util.Textifier#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitMethodInsn(int, java.lang.String, java.lang.String, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitMethodTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitModule(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Textifier#visitModuleEnd(), org.objectweb.asm.util.Textifier#visitMultiANewArrayInsn(java.lang.String, int), org.objectweb.asm.util.Textifier#visitNestHost(java.lang.String), org.objectweb.asm.util.Textifier#visitNestMember(java.lang.String), org.objectweb.asm.util.Textifier#visitOpen(java.lang.String, int, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitOuterClass(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitPackage(java.lang.String), org.objectweb.asm.util.Textifier#visitParameter(java.lang.String, int), org.objectweb.asm.util.Textifier#visitParameterAnnotation(int, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitParameterAnnotation(int, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitPermittedSubclass(java.lang.String), org.objectweb.asm.util.Textifier#visitProvide(java.lang.String, [Ljava.lang.String;), org.objectweb.asm.util.Textifier#visitRecordComponent(java.lang.String, java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitRecordComponentAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitRecordComponentAnnotation(java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitRecordComponentAttribute(org.objectweb.asm.Attribute), org.objectweb.asm.util.Textifier#visitRecordComponentEnd(), org.objectweb.asm.util.Textifier#visitRecordComponentTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitRequire(java.lang.String, int, java.lang.String), org.objectweb.asm.util.Textifier#visitSource(java.lang.String, java.lang.String), org.objectweb.asm.util.Textifier#visitTableSwitchInsn(int, int, org.objectweb.asm.Label, [Lorg.objectweb.asm.Label;), org.objectweb.asm.util.Textifier#visitTryCatchAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitTryCatchBlock(org.objectweb.asm.Label, org.objectweb.asm.Label, org.objectweb.asm.Label, java.lang.String), org.objectweb.asm.util.Textifier#visitTypeAnnotation(int, org.objectweb.asm.TypePath, java.lang.String, boolean), org.objectweb.asm.util.Textifier#visitTypeInsn(int, java.lang.String), org.objectweb.asm.util.Textifier#visitUse(java.lang.String), org.objectweb.asm.util.Textifier#visitVarInsn(int, int), org.objectweb.asm.util.Textifier#wait(), org.objectweb.asm.util.Textifier#wait(long), org.objectweb.asm.util.Textifier#wait(long, int)`

- - ### Constructor Detail

    - #### public LoggableTextifier()

      Creates a textifier that uses the default compiler configuration for stack-trace enrichment.

    - #### public LoggableTextifier(CompilerConfiguration compilerConfiguration)

      Creates a textifier that logs emitted bytecode using the supplied compiler configuration.

  - ### Method Detail

    - #### protected org.objectweb.asm.util.Textifier createTextifier()

      Creates a new org.objectweb.asm.util.Textifier.

      Returns:
        a new org.objectweb.asm.util.Textifier.

    - #### protected void log()

      Logs any newly collected bytecode text since the previous visitor callback.

    - #### public void visit(int version, int access, String name, String signature, String superName, String[] interfaces)

    - #### public void visit(String name, Object value)

    - #### public org.objectweb.asm.util.Textifier visitAnnotableParameterCount(int parameterCount, boolean visible)

    - #### public org.objectweb.asm.util.Textifier visitAnnotation(String name, String desc)

    - #### public org.objectweb.asm.util.Textifier visitAnnotation(String desc, boolean visible)

    - #### public org.objectweb.asm.util.Textifier visitAnnotationDefault()

    - #### public void visitAnnotationEnd()

    - #### public org.objectweb.asm.util.Textifier visitArray(String name)

    - #### public void visitAttribute(org.objectweb.asm.Attribute attr)

      Prints a disassembled view of the given attribute.

      Parameters:
        `attribute` - an attribute.

    - #### public org.objectweb.asm.util.Textifier visitClassAnnotation(String desc, boolean visible)

    - #### public void visitClassAttribute(org.objectweb.asm.Attribute attr)

    - #### public void visitClassEnd()

    - #### public org.objectweb.asm.util.Printer visitClassTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### public void visitCode()

    - #### public void visitEnum(String name, String desc, String value)

    - #### public void visitExport(String export, int access, String modules)

    - #### public org.objectweb.asm.util.Textifier visitField(int access, String name, String desc, String signature, Object value)

    - #### public org.objectweb.asm.util.Textifier visitFieldAnnotation(String desc, boolean visible)

    - #### public void visitFieldAttribute(org.objectweb.asm.Attribute attr)

    - #### public void visitFieldEnd()

    - #### public void visitFieldInsn(int opcode, String owner, String name, String desc)

    - #### public org.objectweb.asm.util.Printer visitFieldTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### public void visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)

    - #### public void visitIincInsn(int varIndex, int increment)

    - #### public void visitInnerClass(String name, String outerName, String innerName, int access)

    - #### public void visitInsn(int opcode)

    - #### public org.objectweb.asm.util.Printer visitInsnAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### public void visitIntInsn(int opcode, int operand)

    - #### public void visitInvokeDynamicInsn(String name, String desc, org.objectweb.asm.Handle bsm, Object bsmArgs)

    - #### public void visitJumpInsn(int opcode, org.objectweb.asm.Label label)

    - #### public void visitLabel(org.objectweb.asm.Label label)

    - #### public void visitLdcInsn(Object cst)

    - #### public void visitLineNumber(int line, org.objectweb.asm.Label start)

    - #### public void visitLocalVariable(String name, String desc, String signature, org.objectweb.asm.Label start, org.objectweb.asm.Label end, int index)

    - #### public org.objectweb.asm.util.Printer visitLocalVariableAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, org.objectweb.asm.Label[] start, org.objectweb.asm.Label[] end, int[] index, String desc, boolean visible)

    - #### public void visitLookupSwitchInsn(org.objectweb.asm.Label dflt, int[] keys, org.objectweb.asm.Label[] labels)

    - #### public void visitMainClass(String mainClass)

    - #### public void visitMaxs(int maxStack, int maxLocals)

    - #### public org.objectweb.asm.util.Textifier visitMethod(int access, String name, String desc, String signature, String[] exceptions)

    - #### public org.objectweb.asm.util.Textifier visitMethodAnnotation(String desc, boolean visible)

    - #### public void visitMethodAttribute(org.objectweb.asm.Attribute attr)

    - #### public void visitMethodEnd()

    - #### @Deprecated
      public void visitMethodInsn(int opcode, String owner, String name, String desc)

      Method instruction. See jdk.internal.org.objectweb.asm.MethodVisitor#visitMethodInsn.

      deprecated:
        use visitMethodInsn(int, String, String, String, boolean) instead.
      Parameters:
        `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
        `owner` - the internal name of the method's owner class (see jdk.internal.org.objectweb.asm.Type#getInternalName()).
        `name` - the method's name.
        `descriptor` - the method's descriptor (see jdk.internal.org.objectweb.asm.Type).

    - #### public void visitMethodInsn(int opcode, String owner, String name, String desc, boolean itf)

    - #### public org.objectweb.asm.util.Printer visitMethodTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### public org.objectweb.asm.util.Printer visitModule(String name, int access, String version)

    - #### public void visitModuleEnd()

    - #### public void visitMultiANewArrayInsn(String desc, int dims)

    - #### public void visitNestHost(String nestHost)

    - #### public void visitNestMember(String nestMember)

    - #### public void visitOpen(String packaze, int access, String modules)

    - #### public void visitOuterClass(String owner, String name, String desc)

    - #### public void visitPackage(String packaze)

    - #### public void visitParameter(String name, int access)

    - #### public org.objectweb.asm.util.Textifier visitParameterAnnotation(int parameter, String desc, boolean visible)

    - #### public void visitPermittedSubclass(String permittedSubclass)

    - #### public void visitProvide(String provide, String providers)

    - #### public org.objectweb.asm.util.Printer visitRecordComponent(String name, String descriptor, String signature)

    - #### public org.objectweb.asm.util.Textifier visitRecordComponentAnnotation(String descriptor, boolean visible)

    - #### public void visitRecordComponentAttribute(org.objectweb.asm.Attribute attribute)

    - #### public void visitRecordComponentEnd()

    - #### public org.objectweb.asm.util.Printer visitRecordComponentTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String descriptor, boolean visible)

    - #### public void visitRequire(String require, int access, String version)

    - #### public void visitSource(String file, String debug)

    - #### public void visitTableSwitchInsn(int min, int max, org.objectweb.asm.Label dflt, org.objectweb.asm.Label labels)

    - #### public org.objectweb.asm.util.Printer visitTryCatchAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

    - #### public void visitTryCatchBlock(org.objectweb.asm.Label start, org.objectweb.asm.Label end, org.objectweb.asm.Label handler, String type)

    - #### public org.objectweb.asm.util.Textifier visitTypeAnnotation(int typeRef, org.objectweb.asm.TypePath typePath, String desc, boolean visible)

      Prints a disassembled view of the given type annotation.

      Parameters:
        `typeRef` - a reference to the annotated type. See TypeReference.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be null if the annotation targets 'typeRef' as a whole.
        `descriptor` - the class descriptor of the annotation class.
        `visible` - true if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values.

    - #### public void visitTypeInsn(int opcode, String type)

    - #### public void visitUse(String use)

    - #### public void visitVarInsn(int opcode, int varIndex)